Unit Ablakok;
{
  Ablak-kezels a szimulcis programokhoz.
}

Interface

  Uses
    {$IFDEF FPC --FreePascal}
    Crt,
    {$ELSE -- TurboPascal}
    Newdelay,Crt,
    {$ENDIF}
    Graph;
  Const
    MaxN       = 250;  {Reakcitr fggleges mretnek maximuma}
    MaxM       = 250;  {Reakcitr vizszintes mretnek maximuma}
    MaxDb      = 250;  {Hisztogramoszlopok max. szma}
    MaxMDb     =  10;  {Max. mezk szma a TKarAblakban}
    MaxCimHossz=  64;  {Az ablakbeli cmek maximlis hossza}
  Type
    TKepModok =(Grafikus,Szoveges);
    TUzemModok=(Normal,Lepesenkenti,Csendes,Vege);
  Const
    SUzemModok : Array [TUzemModok] of String=
                  ('Normal','Lepesenkenti','Csendes','Vege');
  Type
    TAblak=Record
             bfx, bfy, jax, jay : Word;
             cim                : String[MaxCimHossz];
             szin               : Byte; 
           End;
    THisztAblak=Record
                  bfx, bfy, jax, jay : Word;
                  cim                : String[MaxCimHossz];
                  adatDb             : Word;
                  leptek             : Real;
                  adatok             : Array [0..MaxDb] of Word;
                  szin               : Byte
                End;
    TKarAblak=Record
                bfx, bfy, jax, jay : Word;
                cim                : String[MaxCimHossz];
                adatDb             : Word;
                adatok             : Array [0..MaxMDb] of 
                                          Record
                                            nev,ert:String;
                                          End;
                szin               : Byte
              End;
    TCella =(Fal,Ures,Reszecske);
    TReaTer=Array [0..MaxN+1,0..MaxM+1] of TCella;

  Const
    HelpSor= ' V/v: vge , L/l: lpsenknt , N/n: norml , C/c: csendes ';
    Path   = 'c:\langs\tp\bgi\';
    rSzin  = Yellow; uSzin = Black; fSzin= Blue;
  Var
    //llapot-paramterek:
    KepMod :TKepModok;
    UzemMod:TUzemModok;
    //Szimulcis mret-paramterek:
 {Kpernymentshez.
  Csak globlisan lehet ekkora adatot
  trolni a STACK OVERFLOW hiba nlkl:}
  Const
    {$IFDEF FPC --FreePascal}
    pufMeret=550000;
    {$ELSE -- TurboPascal}
    pufMeret=30000;
    {$ENDIF}
   Var
     puf : Array [1..pufMeret] of byte;
  Function  HisztogramMozgatoPufferMerete(Const Graf:THisztAblak):LongInt;

  Procedure BillentyureVar(Var c: Char);
  Procedure SzovegesLap(Const Fejlec:String);
  Procedure Tajekoztato(Const Fejlec,TajekoztatoFile:String);
  Function  TP2FP_Y(y:Integer):Integer;
  Function  TP2FP_X(x:Integer):Integer;
  Procedure FoIdoKiiras({Const FoAblak:TFoAblak;} Const T:LongInt);
  Procedure ReaIdoKiiras(Const TerAblak:TAblak; Const T:LongInt);
  Procedure IdoKiiras(Const Graf:THisztAblak; Const T:LongInt);
  Procedure KarIdoKiiras(Const KarAblak:TKarAblak; Const T:LongInt);
  Procedure GrafikusKepernyoAllandoReszei(Const Fejlec:String);
  Procedure KarAblakLetrehozas(Var KarAblak:TKarAblak;
                               Const bx,by,jx,jy:Word;
                               Const c:String; Const sz:Byte);
  Procedure KarAblakUjMezo(Var KarAblak:TKarAblak; Const nev,ert:String);
  Procedure KarAblakUjErtek(Var KarAblak:TKarAblak; Const nev,ert:String);
  Procedure KarAblakRajzolas(Const KarAblak:TKarAblak);
  Procedure ReaAblakLetrehozas(Var TerAblak:TAblak;
                               Const bx,by,jx,jy:Word;
                               Const c:String; Const sz:Byte);
  Procedure ReaTerAblakRajzolas(Const TerAblak:TAblak);
  Procedure ReaTerUjraRajzol(Const TerAblak:TAblak;
                             Const ReaTer:TReaTer; Const N,M:Integer;
                             Const T:LongInt);
  Procedure AblakLetrehozas(Var Graf : THisztAblak;
                            Const bx,by,jx,jy:Word;
                            Const c:String; Const aDb:Word;
                            Const l:Real; Const sz:Byte);
  Procedure AblakRajzolas(Const Graf:THisztAblak);
  Procedure TeljesGrafikon(Var Graf:THisztAblak);
  Procedure EloszlasFv(Szam:Word; Var Graf:THisztAblak; Const T:LongInt);
  Procedure IdoDiagram(Szam:Word; Var Graf:THisztAblak; Const T:LongInt);
  Procedure ReszecskeRajzolas(Const TerAblak:TAblak; Const N,M:Integer;
                              Const i,j:Integer; Const c:TCella);

Implementation

  {Karakteres kperny- s billenty-kezels: ------------------------------}

  Procedure BillentyureVar(Var c: Char);
    {* Billentyfigyels
     * Vrakozskijelzs
     * zemmdbellts}
  Begin
    If KepMod=Szoveges then
    Begin
      c:='-';
      Repeat
        Case c of
          '|': c:='/';
          '/': c:='-';
          '-': c:='\';
          '\': c:='|';
        End;
        Window(1,1,80,25); GotoXY(35,25); Write('Lapozhatunk?',c);
        Delay(100);
      Until KeyPressed;
      c:=ReadKey;
    End
      Else {Grafikus md}
    Begin
      If UzemMod=Lepesenkenti Then
      Begin
        c:=ReadKey;
        Case c of
          'n','N': UzemMod:=Normal;
          'l','L': UzemMod:=Lepesenkenti;
          'c','C': UzemMod:=Csendes;
          'v','V': UzemMod:=Vege;
        End
      End
        Else
      If KeyPressed then
      Begin
        c:=ReadKey;
        Case c of
          'n','N': UzemMod:=Normal;
          'l','L': UzemMod:=Lepesenkenti;
          'c','C': UzemMod:=Csendes;
          'v','V': UzemMod:=Vege;
        End;
      End
        Else
      Begin
        c:=' ';{a definiltsg kedvrt}
      End;
    End;
  End; {BillentyureVar}

  Procedure SzovegesLap(Const Fejlec:String);
    {Standard mret, keretes, cmes, karakteres-kperny}
    Var
       i,fejHossz:Integer;
  Begin
    fejHossz:=Length(fejlec);
    If KepMod=Grafikus then RestoreCrtMode;
    KepMod:=Szoveges;
    Window(1,1,80,25); ClrScr;
    For i:=2 to 79 do
    Begin
      GotoXY(i,1); Write(''); GotoXY(i,24); Write('');
    End;
    For i:=1 to 24 do
    Begin
      GotoXY(1,i); Write(''); GotoXY(80,i); Write('');
    End;
    HighVideo;
    GotoXY(40-(fejHossz div 2),1); Write(fejlec);
    NormVideo;
    Window(3,3,78,23);
  End; {SzovegesLap}

  Procedure Tajekoztato(Const Fejlec,TajekoztatoFile:String);
    {Tjkoztat lapozott kirsa a kpernyre fjlbl}
    Var
       c  : Char;
       s  : Byte;
       sor: String;
       tf : Text;
  Begin
      {A tjkoztat szvege:}
    Assign(tf,TajekoztatoFile);
    {$i-}
    Reset(tf);
    {$i+}
    If IOResult=0 then
    Begin
      While not Eof(tf) do
      Begin
        SzovegesLap(Fejlec); s:=1;
        Repeat
          If s>1 then Writeln;
          Readln(tf,sor); Write(sor); Inc(s)
        Until Eof(tf) or (s=20);
        BillentyureVar(c);
      End;
      Close(tf);
    End
       Else
    Begin
      HighVideo; Writeln('  Nincs meg a tjkoztat fjl!!!  '); NormVideo;
      BillentyureVar(c)
    End;
  End; {Tajekoztato}

  {------------------------------- Karakteres kperny- s billenty-kezels}

  {Ablakok, grafikonok kezelse: -------------------------------------------}

  {TP-rl FP-re trs miatt:}
  Function TP2FP_X(x:Integer):Integer;
  Begin
  {$IFDEF FPC --FreePascal}
    TP2FP_X:=Trunc(x*GetMaxX/640)
  {$ELSE --TurboPascal}
    TP2FP_X:=x
  {$ENDIF}
  End;

  Function TP2FP_Y(y:Integer):Integer;
  Begin
  {$IFDEF FPC --FreePascal}
    TP2FP_Y:=Trunc(y*GetMaxY/480)
  {$ELSE --TurboPascal}
    TP2FP_Y:=y
  {$ENDIF}
  End;
  {--------------------------------------------------------------------}

  Procedure GrafikusKepernyoAllandoReszei(Const Fejlec:String);
  {Ef: Grafikus zemmdban.
  }
    Var
      st   : String;
      lst,
      cx,cy: Integer;
      gFejHossz: Integer;
  Begin
    gFejHossz:=Length(Fejlec)*TextWidth(' ');
    SetTextJustify(CenterText,TopText);
    SetLineStyle(SolidLn,0,{NormWidth}ThickWidth);
    SetViewPort(0,0, GetMaxX,GetMaxY, ClipOn);
    Rectangle(6,6, GetMaxX-5,GetMaxY-5);
      {CimAblak: cimkiirsa:}
    cx:=GetMaxX div 2; cy:=TextHeight(' ') div 2;
    SetViewPort(cx-(gFejHossz div 2)-8,0,
                cx+(gFejHossz div 2)+7,2*cy+7, ClipOn);
    ClearViewPort;
    Rectangle(4,2, gFejHossz+9,2*cy+5);
    OutTextXY((gFejHossz+15){6} div 2,4,Fejlec);
      {IdAblak: T kiirsa:}
    FoIdoKiiras(0);
      {HelpAblak: Help-sor:}
    st:=HelpSor; lst:=Length(st)*TextWidth(' ');
    SetViewPort(cx-(lst div 2)-8,GetMaxY-TextHeight(' ')-6,
                cx+(lst div 2)+7,GetMaxY, ClipOn);
    ClearViewPort;
    Rectangle(2,2, lst+9,2*cy+5);
    OutTextXY((lst+15) div 2,4,st);
    SetTextJustify(LeftText,TopText);
  End; {GrafikusKepernyoAllandoReszei}

  {Ablakfgg idkirsok: ---------------------------------------------}

  Function HisztogramMozgatoPufferMerete(Const Graf:THisztAblak):LongInt;
  Begin
    HisztogramMozgatoPufferMerete:=
      ImageSize(Graf.bfx,Graf.bfy+TextHeight(' '),
                Graf.jax,Graf.jay)
  End; {HisztogramMozgatoPufferMerete}
    
  Procedure FoIdoKiiras({Const FoAblak:TFoAblak;} Const T:LongInt);
    Var 
      lst: Word;
      st : String;
  Begin
    Str(T:5,st); st:=' T:'+st; lst:=12*TextWidth(' ');
    SetViewPort(GetMaxX-lst-8,0, GetMaxX,TextHeight(' ')+7, ClipOn);
    ClearViewPort;
    Rectangle(2,2, lst+5,TextHeight(' ')+5);
    OutTextXY(4,4,st);
    SetViewPort(0,0,GetMaxX,GetMaxY,ClipOn);
  End; {FoIdoKiiras}

  Procedure ReaIdoKiiras(Const TerAblak:TAblak; Const T:LongInt);
    Var 
      lst: Word;
      st : String;
  Begin
    With TerAblak do
    Begin
      Str(T:0,st); st:=' T:'+st; lst:=16*TextWidth(' ');
      SetViewPort(bfx+4,bfy+TextHeight(' '),
                  bfx+4+lst,bfy+2*TextHeight(' ')+1, ClipOn);
      ClearViewPort;
      SetViewPort(0,0, GetMaxX,GetMaxY, ClipOn);
      OutTextXY(bfx+2,bfy+TextHeight(' '),st); //??????????????????????????????????????????????????????
    End;
  End; {ReaIdoKiiras}
  
  Procedure IdoKiiras(Const Graf:THisztAblak; Const T:LongInt);
    Var 
      lst: Word;
      st : String;
  Begin
    With Graf do
    Begin
      Str(T:0,st); st:=' T:'+st; lst:=16*TextWidth(' ');
      SetViewPort(bfx+4,bfy+TextHeight(' '),
                  bfx+4+lst,bfy+2*TextHeight(' ')+1, ClipOn);
      ClearViewPort;
      SetViewPort(0,0, GetMaxX,GetMaxY, ClipOn);
      OutTextXY(bfx+2,bfy+TextHeight(' '),st);
    End;
  End; {IdoKiiras}
  
  Procedure KarIdoKiiras(Const KarAblak:TKarAblak; Const T:LongInt);
    Var 
      lst: Word;
      st : String;
  Begin
    With KarAblak do
    Begin
      Str(T:0,st); st:=' T:'+st; lst:=16*TextWidth(' ');
      SetViewPort(bfx+4,bfy+TextHeight(' '),
                  bfx+4+lst,bfy+2*TextHeight(' ')+1, ClipOn);
      ClearViewPort;
      SetViewPort(0,0, GetMaxX,GetMaxY, ClipOn);
      OutTextXY(bfx+2,bfy+TextHeight(' '),st);
    End;
  End; {KarIdoKiiras}

  {---------------------------------------------- Ablakfgg idkirsok}
  
  Procedure KarAblakLetrehozas(Var KarAblak:TKarAblak;
                               Const bx,by,jx,jy:Word;
                               Const c:String; Const sz:Byte);
  Begin
    With KarAblak do
    Begin
      cim:=c;
      bfx:=bx; bfy:=by; jax:=jx; jay:=jy;
      adatDb:=0;
      szin:=sz;
    End;
  End; {KarAblakLetrehozas}

  Procedure KarAblakUjMezo(Var KarAblak:TKarAblak; Const nev,ert:String);
  { A KarAblak-ban ltrehoz, ha tud, egy jabb mezt.
    Nem ellenrzm, h. egyedi-e.
    Ha nem vehet fl az jabb mez, megllok.
    (Ez nem problma, mivel gyis "tervezsi" fzisban lphet csak fl
     e hiba.) 
  }
  Begin
    With KarAblak do
    Begin
      If adatDb<MaxMDb then
      Begin
        Inc(adatDb);
        adatok[adatDb].nev:=nev; adatok[adatDb].ert:=ert;
      End
        else {Hiba: megllok}
      Begin
        Writeln('Tl sok mez (',nev,' nev) az egyik KarAblak-ban!');
        Halt(1);
      End;
    End; {With}
  End; {KarAblakUjMezo}
                     
  Procedure KarAblakUjErtek(Var KarAblak:TKarAblak; Const nev,ert:String);
  { A KarAblak-ban a nev meznek j rtket ad.
    Ha nem adhat rtk a meznek, megllok.
    (Ez nem problma, mivel gyis "tervezsi" fzisban lphet csak fl
     e hiba.) 
  }
    Var
      i:Integer;
  Begin
    With KarAblak do
    Begin
      If adatDb<MaxMDb then
      Begin
        i:=1;
        While (i<=adatDb) and (adatok[i].nev<>nev) do Inc(i);
        If i<=adatDb then
        Begin
          adatok[i].ert:=ert;
        End
          else {Hiba: megllok}
        Begin
          Writeln('Nem ltez (',nev,' nev) mez az egyik KarAblak-ban!');
          Halt(2);
        End;
      End;
    End; {With}
  End; {KarAblakUjErtek}
                     
  Procedure KarAblakRajzolas(Const KarAblak:TKarAblak);
    Var
      i,cx,cy:Integer;
  Begin
    SetViewPort(0,0,GetMaxX,GetMaxY,ClipOn);
    With KarAblak do
    Begin
      Rectangle(bfx,bfy,jax,jay);
      cx:=(jax-bfx) div 2+bfx; cy:=TextHeight(' ')+bfy;
      SetTextJustify(CenterText,TopText);
      OutTextXY(cx,cy,cim);
      SetTextJustify(LeftText,TopText);
      SetViewPort(bfx,bfy+TextHeight(' '),jax,jay,ClipOn);
      For i:=1 to adatDb do
      Begin
        {elz rtk trlse:}
        SetFillStyle(EmptyFill,Black{brmi});
        Bar(10,i*(TextHeight(' ')+5),
            jax-bfx-10,(i+1)*(TextHeight(' ')+5));
        {j rtk kirsa:}
        OutTextXY(10,i*(TextHeight(' ')+5),
                  adatok[i].nev+':'+adatok[i].ert);
        
      End;
      SetViewPort(0,0,GetMaxx,GetMaxy,ClipOn);
      {Grafikus llapot visszalltsa:}
      SetTextJustify(LeftText,TopText);
      SetFillStyle(SolidFill,GetMaxColor);
    End;
  End; {KarAblakRajzolas}

  Procedure ReaAblakLetrehozas(Var TerAblak:TAblak;
                               Const bx,by,jx,jy:Word;
                               Const c:String; Const sz:Byte);
  Begin
    With TerAblak do
    Begin
      cim:='Reakcitr';
      bfx:=bx; bfy:=by; jax:=jx; jay:=jy;
      szin:=sz;
    End;
  End; {ReaAblakLetrehozas}
                                
  Procedure ReaTerAblakRajzolas(Const TerAblak:TAblak);
    Var
      cx,cy:Integer;
  Begin
    SetViewPort(0,0,GetMaxX,GetMaxY,ClipOn);
    With TerAblak do
    Begin
      Rectangle(bfx,bfy,jax,jay);
      cx:=(jax-bfx) div 2+bfx; cy:=TextHeight(' ')+bfy;
      SetTextJustify(CenterText,TopText);
      OutTextXY(cx,cy,cim);
      SetTextJustify(LeftText,TopText);
    End;
  End; {ReaTerAblakRajzolas}

  Procedure AblakLetrehozas(Var Graf : THisztAblak;
                            Const bx,by,jx,jy:Word;
                            Const c:String; Const aDb:Word;
                            Const l:Real; Const sz:Byte);
  {Ef: Grafikus ablak nyitva}
    Var
      i:Integer;
      b:Char;
  Begin
    With Graf do
    Begin
      cim:=c;
      bfx:=bx; bfy:=by; jax:=jx; jay:=jy;
      adatDb:=aDb;
      leptek:=l;
      For i:=0 to MaxDb do adatok[i]:=0;
      szin:=sz;
    End;
    If HisztogramMozgatoPufferMerete(Graf)>Sizeof(puf) then
    Begin
      CloseGraph; {grafikus zemmd lezrva!}
      SzovegesLap('Hibazenet!');
      Writeln('Sajnos kicsi a hisztogram-mentshez rendelt temporlis memria,');
      Writeln('ezrt a program nem tud futni. Megll.');
      Writeln;
      Writeln('A "puffMeret" konstans rtkt nvelni kell ekkorra:');
      Writeln(HisztogramMozgatoPufferMerete(Graf));
      Writeln('Szlj a programoznak! :)');
      Writeln;
      BillentyureVar(b);
      Halt(1);
    End;
  End; {AblakLetrehozas}

  Procedure AblakRajzolas(Const Graf : THisztAblak);
    Var
      cx,cy:Integer;
  Begin
    SetViewPort(0,0,GetMaxX,GetMaxY,ClipOn);
    With Graf do
    Begin
      SetFillStyle(SolidFill,szin);
      Rectangle(bfx,bfy,jax,jay);
      cx:=(jax-bfx) div 2+bfx; cy:=TextHeight(' ')+bfy;
      SetTextJustify(CenterText,TopText);
      OutTextXY(cx,cy,cim);
      SetTextJustify(LeftText,TopText);
    End;
  End; {AblakRajzolas}

  Procedure TeljesGrafikon(Var Graf : THisztAblak);
    {lptkezs s a grafikon jrarajzolsa}
    Var i,max: Integer;
        osz: Word;
  Begin
    With Graf do
    Begin
      osz:=((jax-bfx) div (adatDb+1));
      SetFillStyle(EmptyFill,Black{brmi});
      Bar(bfx+2,bfy+TextHeight(' ')+10,jax-2,jay-2);
      SetFillStyle(SolidFill,szin);
      {Maximumkivlaszts:}
      max:=1;{max 0-nl legyen nagyobb!}
      For i:=0 to adatDb-1 do If adatok[i]>max then max:=adatok[i];
      {lptkezs:}
      leptek:=(jay-2-bfy-TextHeight(' ')-10)/max;
      {jrarajzols:}
      For i:=0 to adatDb-1 do
      Begin
        bar(bfx+osz*(i)+2,  jay-2-Trunc(adatok[i]*leptek),
            bfx+osz*(i+1)+1,jay-2);
      End;
    End;
  End;{TeljesGrafikon}

  Procedure EloszlasFv(Szam: Word; Var Graf:THisztAblak; Const T:LongInt);
    {a Szam-adik hisztogram-oszlop eggyel nvekszik, T-kor}
    Var
      osz: Word;
  Begin
    With Graf do
    Begin
      Inc(Adatok[Szam]);
        {Megjelents:}
      If UzemMod<>Csendes then
        {nem csendes zemmdban:}
      Begin
        SetFillStyle(SolidFill,szin);
        IdoKiiras(Graf,T);
        If Adatok[Szam]*leptek<(jay-bfy-TextHeight(' ')-10) then
        Begin
          osz:=((jax-bfx) div (adatDb+1));
          bar(bfx+osz*(Szam)+2,Trunc(jay-adatok[Szam]*leptek),
              bfx+osz*(Szam+1)+1,jay);
        End
          Else
        Begin
          TeljesGrafikon(Graf);
        End;
      End
    End;
  End;{EloszlasFv}

  Procedure IdoDiagram(Szam: Word; Var Graf:THisztAblak; Const T:LongInt);
    {az IdoDiagram jobbra egy Szam magassg oszloppal bvl,
     vagy shift-eldnek oszlopai eggyel balra, majd bvl, T-kor}
    Var
      osz: Word;
      i  : Integer;
  Begin
    With Graf do
    Begin
      If UzemMod<>Csendes then
        {nem csendes zemmdban:}
      Begin
        SetFillStyle(SolidFill,szin);
        IdoKiiras(Graf,T);
      End;
      If adatDb<=MaxDb then
      Begin
        {adat hozzvtel a vgn:}
        adatok[adatDb]:=Szam;
        Inc(adatDb);
        If UzemMod<>Csendes then
          {nem csendes zemmdban:}
        Begin
          TeljesGrafikon(Graf);
        End;
      End
        else{adatDb=MaxDb+1}
      Begin
        {Shift-els balra:}
        for i:=1 to adatDb-1 do adatok[i-1]:=adatok[i];
        {adat hozzvtel utolsknt:}
        adatok[adatDb-1]:=Szam;
        If UzemMod<>Csendes then
          {nem csendes zemmdban:}
        Begin
          osz:=((jax-bfx) div (adatDb+1));
          If Szam*leptek<(jay-bfy-TextHeight(' ')-10) then
          Begin
            GetImage(bfx+osz+2,bfy+TextHeight(' ')+10,
                     bfx+osz*(adatDb+1)+1,jay, puf);
            PutImage(bfx+2,    bfy+TextHeight(' ')+10,
                     puf,NormalPut);
            bar(bfx+osz*(adatDb-1)+2,Trunc(jay-Szam*leptek),
                bfx+osz*adatDb+1,jay);
          End
            Else
          Begin
            TeljesGrafikon(Graf);
          End;
        End; {If UzemMod}
      End; {If adatDb}
    End;
  End; {IdoDiagram}

  Procedure ReszecskeRajzolas(Const TerAblak:TAblak; Const N,M:Integer;
                              Const i,j:Integer; Const c:TCella);
  Begin
    If uzemMod<>Csendes then
    Begin
      With TerAblak do
      Begin
        SetViewPort((bfx+jax-M) Div 2, 4*TextHeight(' ')+
                       (jay-bfy-TextHeight(' ')) Div 2-(N Div 2),
                    (bfx+jax+M+2) Div 2, jay, ClipOn);
        Case c of
          Reszecske: PutPixel(j,i,rSzin);
          Ures     : PutPixel(j,i,uSzin);
          Fal      : PutPixel(j,i,fSzin);
        End;
      End;
      SetViewPort(0,0, GetMaxX,GetMaxY, ClipOn);
    End;
  End;{ReszecskeRajzolas}

  Procedure ReaTerUjraRajzol(Const TerAblak:TAblak;
                             Const ReaTer:TReaTer; Const N,M:Integer;
                             Const T:LongInt);
    Var
      i,j: Word;
      RegiUzemMod: TUzemModok;
  Begin
    RegiUzemMod:=UzemMod;
    ReaIdoKiiras(TerAblak,T);
    UzemMod:=Normal; {ideiglenesen belltva, a rajzols rdekben}
    For i:=0 to N+1 do For j:=0 to M+1 do
    Begin
      ReszecskeRajzolas(TerAblak,N,M,i,j,ReaTer[i,j])
    End;
    UzemMod:=RegiUzemMod; {visszalltva}
  End;{ReaTerUjraRajzolas}

Begin
  KepMod:=Szoveges;
  UzemMod:=Lepesenkenti;
End.
