{
  fp-Verzi: 2.6.4

                      A sikbeli folyadk szimulcis modell.
  Programspecifikci:
    Input:
         paramterek - N,M reakcitr-mretek
                       K az elhelyezend rszecskk szma
                       Ah,Kh adhzis s kohzis egytthat
                       (mekkora a fal-molekula, ill. molekula-molekula
                        kztt hat "er")
                       G gravitcis egytthat
                       rSz szomszdsgi sugr
         tjkoztat fjlok sorokra trdelve
         beavatkozs - billentykkel (nagy s kisbetk nem klnbznek)
                       'c' = csendes zemmd;      'n' = norml  zemmd;
                       'l' = lpsenknti zemmd; 'v' = vge
    Output:
         karakteres kpernyn = tjkoztat lapozott szvege
         grafikus kpernyn   = reakcitr
                                grafikonablakok:
                                1. Eloszls (rszecskk szma vzszintes
                                   szintenknt)
                                2. Iddiagram (a srsg-vltozs egy adott
                                   szinten 'idoDiagValt' idegysgben)
}
Program Szimulacio;

{ -------------------------------------------------------------------------
        Szimulcis program. (A fizikai... szimulcihoz.)

        Megoldsprogram.
  ------------------------------------------------------------------------- }
  Uses
    {$IFDEF FPC --FreePascal}
    Crt,
    {$ELSE -- TurboPascal}
    Newdelay,Crt,
    {$ENDIF}
    Graph,Ablakok;
  Const
    Fejlec         = ' Folyadk ';
    TajekoztatoFajl= 'folyszim.hlp';
    KonkluzioFajl  = 'folyszim.sum';

  Const
    IdoDiagValt = 2000; {ennyi idegysgenknt rajzolja az idDiagramot,
                         a srsget ennyi idre szmolja}
  Var
    {Ablakok: ---------------------------------------------------------}
    TerAblak: TAblak;     {Reakcitr}
    KarAblak: TKarAblak;  {Karakteres informcik}
    Graf1,
    Graf2   : THisztAblak;{Hisztogramok}
    {Szimulcis adatok: paramterek ----------------------------------}
    T       : LongInt;
    N,M,K   : Integer;
    ReaTer  : TReaTer;
    Ah,Kh,G : Real;
    rSz     : Integer;
    ideY,
    innenY  : Integer; {ide, innen lp t a molekula}
    surY    : Array [0..MaxN] of Word; {molekulaszm, szintenknt}
    figyY   : Integer; {ezen a szinten figyeljk a srsg-vltozst}
    osszMol : Word;  {molekulaszm figyY szinten}

  {A lnyegi eljrsok s fggvnyek: ---------------------------------------}

  Procedure Inicializalas;
    {Paramterbeolvass
     Grafikon-parametrizls
     Esemnytr inicializlsa}
    Var
      i,j,
      holX,holY,
      gd,gm:SmallInt;
      s:String;
  Begin
      {Paramterbeolvass innen hinyzik: N,M,K,Ah,Kh,G,rSz rtke}
    SzovegesLap(Fejlec);
      {reakcitr fggleges mrete -- N beolvassa:}
    Repeat
      Write('A reakcitr fggleges mrete? [1-',MaxN:3,']');
      Readln(N);
    Until N in [1..MaxN];
      {reakcitr vzszintes mrete -- M beolvassa:}
    Repeat
      Write('A reakcitr vizszintes mrete? [1-',MaxM:3,']');
      Readln(M);
    Until M in [1..MaxM];
      {rszecskk ssz szma -- K beolvassa:}
    Repeat
      Write('A rszecskk szma? [1-',N*M:3,']');
      Readln(K);
    Until (K<=N*M) and (K>0);
      {adhzi -- Ah beolvassa:}
    Repeat
      Write('Adhzi nagysga? [-1..1]');
      Readln(Ah);
    Until (Ah>=-1) and (Ah<=1);
      {kohzi -- Kh beolvassa:}
    Repeat
      Write('Kohzi nagysga? [-1..1]');
      Readln(Kh);
    Until (Kh>=-1) and (Kh<=1);
      {gravitci -- G beolvassa:}
    Repeat
      Write('A gravitci nagysga (lefel lps valszinsge) ? [-1..1]');
      Readln(G);
    Until (G>=-1) and (G<=1);
      {szomszdsgi sugr -- rSz beolvassa:}
    Repeat
      Write('Szomszdsgi sugr? [1..10]');
      Readln(rSz);
    Until (rSz>=1) and (rSz<=10);

      {Grafikon-parametrizls innen hinyzik (grafikafggen irand meg!):}
    gd:=Detect; InitGraph(gd,gm,Path); ClearViewPort; {csak ideiglenesen!}
    ReaAblakLetrehozas(TerAblak,
                       TP2FP_X(10),TP2FP_Y(20),
                       TP2FP_X(310),TP2FP_Y(240),
                       'Reakcitr',White);
    KarAblakLetrehozas(KarAblak,
                       TP2FP_X(320),TP2FP_Y(20),
                       TP2FP_X(630),TP2FP_Y(240),
                       'Informcik',White);
    KarAblakUjMezo(KarAblak,'zemmd',SUzemModok[UzemMod]);
    Str(N,s); KarAblakUjMezo(KarAblak,'N',s);
    Str(M,s); KarAblakUjMezo(KarAblak,'M',s);
    Str(K,s); KarAblakUjMezo(KarAblak,'K',s);
    Str(Ah:0:0,s); KarAblakUjMezo(KarAblak,'Ah',s);
    Str(Kh:0:0,s); KarAblakUjMezo(KarAblak,'Kh',s);
    Str(G:0:0,s); KarAblakUjMezo(KarAblak,'G',s);
    Str(rSz,s); KarAblakUjMezo(KarAblak,'rSz',s);
    KarAblakUjMezo(KarAblak,'ssz-molszm','0');
    AblakLetrehozas(Graf1,
                    TP2FP_X(10),TP2FP_Y(250),
                    TP2FP_X(310),TP2FP_Y(460),
                    'Srsg-eloszls',
                    N+1,5,White);
    Str(IdoDiagValt,s);
    AblakLetrehozas(Graf2,
                    TP2FP_X(320),TP2FP_Y(250),
                    TP2FP_X(630),TP2FP_Y(460),
                    'Srsg-vltozs '+s+' idegysgenknt',
                    0,TP2FP_Y(460-250-20)/N,White);
    CloseGraph; {grafikus zemmd lezrva!}

       {Esemnytr inicializlsa innen hinyzik:}
       {szimulcis tr generlsa:
        * ressel feltlts
        * falallal krbevtel
        * K db vletlen elhelyezs bellre
        * srsg-szmts}
    For i:=0 to MaxN+1 do 
    Begin
      surY[i]:=0;
      For j:=0 to MaxM+1 do
      Begin
        ReaTer[i,j]:=Ures
      End;
    End;
    For j:=0 to M+1 do
    Begin
      ReaTer[0,j]:=Fal; ReaTer[N+1,j]:=Fal;
    End;
    For i:=1 to N do
    Begin
      ReaTer[i,0]:=Fal; ReaTer[i,M+1]:=Fal;
    End;
    For i:=1 to K do
    Begin
      Repeat
        holX:=Random(M)+1; holY:=Random(N)+1;
      Until ReaTer[holY,holX]=Ures;
      ReaTer[holY,holX]:=Reszecske;
      Inc(surY[holY]);
    End;
    figyY:=N; {ezen a szinten figyeljk a srsg-vltozst}   
    Graf1.adatok:=surY;
    osszMol:=surY[figyY]; {0 volt az eddigi ssz molekulaszm N. szinten ????}
  End; {Inicializalas}

  Procedure KezdoKepernyo;
    {Grafikus kp inicializlsa:
     * CimAblak: cim kiirasa
     * IdAblak: T kirsa
     * HalpAblak: Help-sor kirsa
     * GrafikonAblakok: resen
     * EsemnyTrAblak: kezd llapotban}
    Var
      gd,gm:SmallInt;
  Begin
    {A grafikus kp inicializlsa:}
    If KepMod<>Grafikus then 
    Begin
      KepMod:=Grafikus;
      gd:=Detect; InitGraph(gd,gm,Path); ClearViewPort;
      SetTextJustify(LeftText,TopText);
    End;
    GrafikusKepernyoAllandoReszei(Fejlec);
      {GrafikonAblakok:}
    AblakRajzolas(Graf1);
    AblakRajzolas(Graf2);
      {RekaciTrAblak:}
    ReaTerAblakRajzolas(TerAblak);
    ReaTerUjraRajzol(TerAblak,ReaTer,N,M,T);
      {KarakteresAblak:}
    KarAblakRajzolas(KarAblak);
  End; {KezdoKepernyo}

  Function SzomszedSzam(Const i,j:Integer):Real;
    Var 
      k,l:Integer;
      ss:Real;
      
    Function Min(Const x,y:Integer):Integer;
    Begin
      If x<y then Min:=x else Min:=y
    End; {Min}

    Function Max(Const x,y:Integer):Integer;
    Begin
      If x<y then Max:=y else Max:=x
    End; {Max}

    Function Tav(Const y1,y2,x1,x2:Integer):Real;
    Begin
      Tav:=Sqrt(Sqr(y1-y2)+Sqr(x1-x2))
    End; {Tav}

  Begin {SzomszdSzm}
    (*ide kell a kd*)
  End; {SzomszdSzm}

  Procedure SzimulaciosLepes;
    {A lnyeg:
     1. (i,j):=vletlen hely
     2. (ii,jj):=vletlen szomszdos hely
     3. ha megfelelk((i,j,(ii,jj),SzomszdSzm) akkor
        3.1. csere(ReaTer(i,j),ReaTer(ii,jj))
        3.2. ha kell akkor RszecskeRajzolsok
        3.3. srsg-adminisztrls: innenY, ideY, surY[], osszMol
    }
    Var i,j,
        ii,jj: Integer;
  Begin
       {A lnyeg innen hinyzik:}
    (*ide kell a kd*)
  End; {SzimulaciosLepes}

{--------------------------- ideiglenesen itt ---------------------------}

  Procedure EloszlasFv2(Const no,csok:Word; 
                        Var Graf:THisztAblak; Const T:LongInt);
    {a no-edik hisztogram-oszlop eggyel nvekszik
     a csok-edik eggyel cskken, T-kor}
    Var
      osz: Word;
  Begin
    If no<>csok then
    Begin
      With Graf do
      Begin
        Inc(Adatok[no]); Dec(Adatok[csok]);
          {Megjelents:}
        If UzemMod<>Csendes then
          {nem csendes zemmdban:}
        Begin
          SetFillStyle(SolidFill,szin);
          IdoKiiras(Graf,T);
          If Adatok[no]*leptek<(jay-bfy-TextHeight(' ')-10) then
          Begin
            SetFillStyle(SolidFill,szin);
            osz:=((jax-bfx) div (adatDb+1));
            bar(bfx+osz*(no)+2,Trunc(jay-adatok[no]*leptek),
                bfx+osz*(no+1)+1,jay);
            SetFillStyle(EmptyFill,Black{brmi});
            bar(bfx+osz*(csok)+2,bfy+TextHeight(' ')+10,
                bfx+osz*(csok+1)+1,jay);
            SetFillStyle(SolidFill,szin);
            bar(bfx+osz*(csok)+2,Trunc(jay-adatok[csok]*leptek),
                bfx+osz*(csok+1)+1,jay);
          End
            Else
          Begin
            TeljesGrafikon(Graf);
          End;
        End
      End;
    End; {If}
  End;{EloszlasFv2}

{--------------------------- ideiglenesen itt ---------------------------}

  Procedure EredmenyMegjelenites;
    Var
      s:String;
  Begin
    FoIdoKiiras({FoAblak,}T);
      {Grafikonok:}
    If (T Mod IdoDiagValt)=0 then
    Begin
      IdoDiagram(osszMol,Graf2,T);
    End;
    If T>0 then EloszlasFv2(ideY,innenY,Graf1,T);
    If ((T Mod IdoDiagValt)=0) or (UzemMod=Lepesenkenti) then
    Begin
      //Reakcitr frisstse:
      ReaTerUjraRajzol(TerAblak,ReaTer,N,M,T);
      ReaIdoKiiras(TerAblak,T);
      //srsg eloszls frisstse:
      TeljesGrafikon(Graf1);
      IdoKiiras(Graf1,T);
      //srsg-vltozs frisstse:
      TeljesGrafikon(Graf2);
      IdoKiiras(Graf2,T);
      //Informcis tr frisstse:
      Str(osszMol,s); KarAblakUjErtek(KarAblak,'ssz-molszm',s);
      KarAblakUjErtek(KarAblak,'zemmd',SUzemModok[UzemMod]);
      KarAblakRajzolas(KarAblak);
      KarIdoKiiras(KarAblak,T);
    End;
  End; {EredmenyMegjelenites}

  Function VegeE: Boolean;
    Var
      c: Char;  
      RegiUzemMod: TUzemModok;
  Begin
    RegiUzemMod:=UzemMod;
    BillentyureVar(c);  {esetleges zemmdvlts}
    If (RegiUzemMod<>UzemMod) then
    Begin
      KarAblakUjErtek(KarAblak,'zemmd',SUzemModok[UzemMod]);
      KarAblakRajzolas(KarAblak);
      KarIdoKiiras(KarAblak,T);
      ReaTerUjraRajzol(TerAblak,ReaTer,N,M,T);
      ReaIdoKiiras(TerAblak,T);
    End;
    If UzemMod in [Normal,Lepesenkenti] then ReaIdoKiiras(TerAblak,T);
    {$IFDEF FPC --FreePascal}
    If (RegiUzemMod=Csendes) and (uzemMod in [Normal,Lepesenkenti]) then
      Writeln('zemmdvlts: ',SUzemModok[UzemMod],' (',T,',',c,')');
    {$ENDIF}
    VegeE:=(UzemMod=Vege) {and (automatikus vgllapot rzkels)}
  End; {Vege}

  Procedure OsszefoglaloMegjelenites;
    {A konklzi szvegnek lapozott kirsa a kpernyre
     rszben (?) egy elre preparlt fjlbl,
     rszben (?) a szimulci esemnyfjljbl}
    Var
       c  : Char;
       s  : Byte; {a kirand sor sorszma}
       sor,       {a kirand sor szvege}
       sE,sK,sV: String[80];
       tf : Text;
    Procedure
      Szetszed(Const sor,minel:String; Var sE,sV:String);
      { Ef: minel RSZE sor
      * Uf: sE,sV RSZE sor  S
      *     sor=sE+minel+sV
      }
        Var
         i:Byte;
      Begin
        i:=Pos(minel,sor);
        sE:=Copy(sor,1,i-1); sV:=Copy(sor,i+Length(minel),255); {255=vgig}
      End; {Szetszed}
    
  Begin
      {Az sszefoglal elre elksztett szvege, 
      * beillesztend "konkrtumokkal":
      * <@T@> -- vgid
      * <@N@> -- N-paramter: ...
      * <@K@> -- K-paramter: ...
      * }
    BillentyureVar(c);
    KepMod:=Szoveges; CloseGraph;
    SzovegesLap(Fejlec); 
    Assign(tf,KonkluzioFajl);
    {$i-}
    Reset(tf);
    {$i+}
    If IOResult=0 then
    Begin
      While not Eof(tf) do
      Begin
        SzovegesLap(Fejlec); s:=1;
        Repeat
          If s>1 then Writeln; 
          Readln(tf,sor);
          While Pos('<@T@>',sor)>0 do
          Begin
            Szetszed(sor,'<@T@>',sE,sV); 
            Str(T,sK);
            sor:=sE+sK+sV;
          End;
          While Pos('<@N@>',sor)>0 do
          Begin
            Szetszed(sor,'<@N@>',sE,sV); 
            Str(N,sK);
            sor:=sE+sK+sV;
          End;
          While Pos('<@K@>',sor)>0 do
          Begin
            Szetszed(sor,'<@K@>',sE,sV); 
            Str(K,sK);
            sor:=sE+sK+sV;
          End;
          Write(sor); Inc(s)
        Until Eof(tf) or (s=20);
        BillentyureVar(c);
      End; {While}
      Close(tf);
    End
      Else
    Begin
      HighVideo; Writeln('  Nincs meg az sszefoglal fjl!!!  '); NormVideo;
      BillentyureVar(c)
    End; {If IOResult}
    ClrScr; GotoXY(25,10); Writeln('Itt a vge fuss el vle!!!!');
  End; {OsszefoglaloMegjelenites}

  {--------------------------------------- A lnyegi eljrsok s fggvnyek}

Begin
  UzemMod:=Lepesenkenti;
  Tajekoztato(Fejlec,TajekoztatoFajl);
  Inicializalas; T:=0;
  KezdoKepernyo;
  EredmenyMegjelenites;
  While not VegeE do
  Begin
    Inc(T);
    SzimulaciosLepes;
    EredmenyMegjelenites;
  End;
  OsszefoglaloMegjelenites;
End.
